#pragma once

#include "CoreMinimal.h"
#include "Perk.h"
#include "Templates/SubclassOf.h"
#include "SurveillancePerk.generated.h"

class UStatusEffect;
class AGenerator;
class ADBDPlayer;

UCLASS(Blueprintable, meta=(BlueprintSpawnableComponent))
class USurveillancePerk : public UPerk
{
	GENERATED_BODY()

private:
	UPROPERTY(EditAnywhere)
	float _generatorRevealTime;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	TSubclassOf<UStatusEffect> _increasedRepairNoiseEffectClass;

private:
	UFUNCTION(BlueprintCallable)
	void HandleGeneratorIsDamagedChanged(AGenerator* generator, ADBDPlayer* player);

public:
	UFUNCTION(BlueprintPure)
	float GetGeneratorRevealTime() const;

public:
	USurveillancePerk();
};

FORCEINLINE uint32 GetTypeHash(const USurveillancePerk) { return 0; }
